/************************************************************************/
/*
                CE FICHIER EST UN "include" de EMBOITE.C

 IL CONTIENT L'ALGO DE GLOUTON.C adapt'e pour traiter une multifourche
 a la fois de l'arbre construit par ||* , et aussi la definition de la
 plupart des structs de donnees necessaires aux 2 progs.

ATTENTION : version pouvant inferer un ARBRE PARTIELLEMENT RESOLU

!!!!!!!!! */


/************************************************************************/
#define Max_nb_taxa 51
#define Max_nb_noeuds 2*Max_nb_taxa
#define Gde_Cte 9999

char name[Max_nb_taxa+1][11];

/* Pour stocker les quadruplets (on utilise un bidon) - list dbmt chainee */
typedef struct listequads {
                           int gche[2],dte[2];
			   char typ;
			   struct listequads *suiv,*prec;
			   struct listequads *qdsuiv;
			 } listequads;
listequads *Lq;
int nbquadsLq=0;
/* Pr stocker les 2 parties participant au critere */
typedef struct critere { int x,y,w;} critere;
critere Critere_global;


/*--------- pr emboite.c   -----*/
int Multifourches[Max_nb_noeuds];
int nb_multi=0;
int contient_tax[Max_nb_taxa];

/* BIPARTITIONS : numbip | gche ou dte | liste des objets */ 
int bipartition[Max_nb_noeuds+1][3][Max_nb_taxa]; /* utilise 1er indice depuis 1 */

/* ------- pr Deboite.c ------------- */
typedef struct Qdeconst {
                          int gche[2],dte[2];
			  int sat,nbipconcern,code,seul;
                          struct Qdeconst *suiv;
			} Qdeconst;

typedef struct PtrQuad {
                          Qdeconst *qd;
			  struct PtrQuad *suiv;
			} PtrQuad;

typedef struct Info_arete {
                      int code,supp;
		      critere score;
		      PtrQuad *lq;
		    } Info_arete;

/* -------------- structure de l'arbre non-enracine ------------- */
typedef struct Ttaxon { struct Ttaxon *suiv; int num;} Ttaxon;
/* venant de tree-popping.c */
typedef struct tarbre {
                       int taxa[Max_nb_taxa];  /* liste non-ordonnee */
		       int num; /* du noeud */
                       struct tarbre *voisins[Max_nb_noeuds]; /*non-ordonnee */
		       Ttaxon *tax_sousarb[Max_nb_noeuds]; /* pr chq voisin 
                           ci-dessus, stocke la liste des espces que 
                           sa sous-arbo contient */
                      } tarbre;

/*------- Var Globales ----------*/
tarbre *noeuds[Max_nb_noeuds+1]; /* adressage direct de chq noeud ds
				    l'arbre en fonction de son num*/
tarbre *sommet[Max_nb_taxa+1]; /* ptr du taxon vers le sommet de
				    l'arbre qui le contient */
/* pour stocker les r4-arbres de Q (on a toujours i1<i2, i3<i4, i1<i3) */
short MatQ[Max_nb_taxa+1][Max_nb_taxa+1][Max_nb_taxa+1][Max_nb_taxa+1];

int Nb_Bips=0;
tarbre *Arbre;   /* pointeur sur le noeud de depart */
int Num_prochain_noeud; /* pr numeroter les noeuds internes */
int Nb_noeuds_agreg; /* nb d'elem encore a agreger */
int Nb_taxa;

/*-------------------------------------------------*/
/* typedef struct listequads : ds "resoudmulti.c" */ 
listequads *lquads;
/*--------------*/
FILE *fbip;

float Gains[Max_nb_taxa]; /* stocke les |sat|/|contre| de chq etape */
int represent[Max_nb_taxa+1]; /* nom du noeud interne au sous-arb duquel est
		                   attachee esp i */
int ref[Max_nb_noeuds+1]; /* ref de la lig et col de la matrice pr le noeud i */
int refinv[Max_nb_taxa]; /* idem ms inverse : lig/col -> num noeuds */
float a = 1.0;    /* parametre du critere (x-ay) d'evaluation des
	           agregations candidates */

typedef struct Tagreg { int x,y,w; 
                       listequads *Lqd;} Tagreg;

Tagreg Agi[Max_nb_taxa][Max_nb_taxa];/* convention [lig][col]
                          et 1/2 matrice inf utilisee : lig > col.*/

/*-----------------------------------*/
 
/*--------------------------------------------------*/
int Choix(esp1,esp2)
int *esp1, *esp2;
{/* Glob : x- (y+w)
    Local : lex(y+w,x)
    Si des exequos, choisit au hasard */ 

    /* !! permet les ag_i / x=0,y=0, du moment qu'il reste des
       quadruplets a resoudre ds Q */

int i,j,ch,nieme=0,bestX=0,bestY=0,bestW=0,meilleur=19990;
int egaux=0,nbexequo=1; /* pour les choix exequo */
float score;
for (i=0;i<Nb_noeuds_agreg;i++)
  for (j=0;j<i;j++)
    {
      score = Agi[i][j].y+Agi[i][j].w;
 /* printf("agregation de %d et %d coute score = %f\n",refinv[i],refinv[j],score);*/
     /* Si exequos garde celui qui satisfait le plus de quadruplets */
     if (score == meilleur)
       {
        if (Agi[i][j].x==bestX) {egaux=1;nbexequo++;}
        if (Agi[i][j].x>bestX)  
	  {*esp1=refinv[i];*esp2=refinv[j];bestX=Agi[i][j].x;
           egaux=0;nbexequo=1;}
        }
     if (score < meilleur)
      {meilleur=score;bestX=Agi[i][j].x;
       *esp1=refinv[i];*esp2=refinv[j];egaux=0;nbexequo=1;}
    }
/* si on n'a des exequos, choisir au hasard entre eux */
if (egaux) {

//++pac
#ifdef _PLAN9
  ch=1+((int)floor(rand() % nbexequo));
#else
  ch=1+((int)rint(random() % nbexequo));
#endif
   /*printf("je choisis le numero %d parmi les %d exequos\n",ch,nbexequo);*/
   for (i=0;i<Nb_noeuds_agreg;i++)
     for (j=0;j<i;j++)
       {score = Agi[i][j].y+Agi[i][j].w;
        if ((score == meilleur) && (Agi[i][j].x==bestX)) 
         {nieme++;if (nieme==ch) {*esp1=refinv[i];*esp2=refinv[j];}}
       }
  }
/* renvoie le gain pr le critere global X - Y+W */
/*printf("X=%d Y+W=%d\n",bestX,meilleur);*/
return(bestX-meilleur);
}





/*-----------------------------------*/
int Quelle_Agi(q,lc1,lc2)
listequads *q;int *lc1,*lc2;
{int tmp;
/* Pour le r4-arbre q = ij||kl, renvoie les coord lig/col ds la matrice Agi 
de la case correspondant a l'agregation des branches contenant i et j */
*lc1=ref[represent[q->gche[0]]];
*lc2=ref[represent[q->gche[1]]];
if (*lc1<*lc2) {tmp=*lc1;*lc1=*lc2;*lc2=tmp;}
}
/*--------------------------------------------------*/
void MAJ_Lq_Matrice(nd1,nd2,cptr)
int nd1,nd2,cptr; /* cptr = neo noeud remplacant nd1 et nd2 */
{
/* Parcourt les quadruplets en enlevant ceux satisfaits ou contredits
   par les especes qu'on vient d'assembler. En effet, une fois sat ou
   contredit par une agreg, aucune agglom future ne pourra changer
   leur statut.
   Quant aux autres quads, les utilise pour remplir la matrice diminuee */
listequads *elem,*prec,*q,*qm,*qtmp;
int i,j,plusgd,pluspetit,t1,t2,t3,t4;
int esp1,esp2,lc1,lc2;

/*printf("ref avant modif :\n noeud :");
for (i=1;i<=cptr;i++) printf("%d\t",i);printf("\n        ");
for (i=1;i<=cptr;i++) printf("%d\t",ref[i]);printf("\n");*/

if (ref[nd1]<ref[nd2]) {pluspetit=ref[nd1];plusgd=ref[nd2];}
else                   {pluspetit=ref[nd2];plusgd=ref[nd1];}
ref[cptr]=pluspetit; 
/* --------------------------------- -------*/
/* ------- MAJ DE LA MATRICE DES AGi -------*/
/* --------------------------------- -------*/
/* Supprime chq r4-arbre resolu et les autres r4-arbres lies au meme quad */
/* Pour chacun de ces r4-arb, maj le support de l'Agi concernee */
/*printf("j'enleve les r4-tree du quad ");*/
q=Agi[plusgd][pluspetit].Lqd;
if (q)
  do
    { /*printf("(%d,%d,%d,%d) ",q->gche[0],q->gche[1],q->dte[0],q->dte[1]);*/
      for (qm=q->qdsuiv;qm!=q;qm=qm->qdsuiv)
	{Quelle_Agi(qm,&lc1,&lc2);
	switch (qm->typ) {
	 case 'x':(Agi[lc1][lc2].x)--;break;
	 case 'y':(Agi[lc1][lc2].y)--;break;
	 case 'w':(Agi[lc1][lc2].w)--;break;
	 default:{printf("ERR : r4-tree de type <> (x,y,w)!!!\n"); fflush(stdout); exit(-1);}	/* ++pac */
	 }
	 /* l'enleve physiquement de la liste */
	  if (qm->suiv==qm) Agi[lc1][lc2].Lqd=NULL; /* free ne marche pas */
	  else
	    {if (Agi[lc1][lc2].Lqd==qm) Agi[lc1][lc2].Lqd=qm->suiv;
	     qm->prec->suiv=qm->suiv;qm->suiv->prec=qm->prec;}
        }
      q=q->suiv;}
  while (q!=Agi[plusgd][pluspetit].Lqd); /* tq pas revenu au depart */
else printf("\n\n\tBIZARRE l'Agi resolu ne concerne aucun r4-arbre!!!!\n\n");
fflush(stdout);	/* ++pac */
Agi[plusgd][pluspetit].Lqd=NULL;
/* COMPRIME LA MATRICE DES AGi */
/* 1: le neo nd, z, remplace celui des agreges qui a le plus petit indice */
/* on reaffecte les col et lig aux noeuds */

/* Calcule le support de la neo agreg */
for (i=0;i<Nb_noeuds_agreg;i++)
  { 
  if ((i!=pluspetit) && (i!=plusgd))
    {if (i<pluspetit)  /*i < pluspetit < plusgd */
     {Agi[pluspetit][i].x=Agi[pluspetit][i].x+Agi[plusgd][i].x;
      Agi[pluspetit][i].y=Agi[pluspetit][i].y+Agi[plusgd][i].y;
      Agi[pluspetit][i].w=Agi[pluspetit][i].w+Agi[plusgd][i].w;
      /* Union en O(1) des listes de r4-arbres dbmt chainees */
      if (Agi[plusgd][i].Lqd)
	{if (!Agi[pluspetit][i].Lqd) 
	   Agi[pluspetit][i].Lqd=Agi[plusgd][i].Lqd;
	else {
	  Agi[pluspetit][i].Lqd->prec->suiv=Agi[plusgd][i].Lqd;
	  Agi[plusgd][i].Lqd->prec->suiv=Agi[pluspetit][i].Lqd;
	  qtmp=Agi[pluspetit][i].Lqd->prec;
	  Agi[pluspetit][i].Lqd->prec=Agi[plusgd][i].Lqd->prec;
	  Agi[plusgd][i].Lqd->prec=qtmp;}}	 
     }
     if (i>pluspetit)
      {if (i<plusgd) /* pluspetit < i < plusgd */
	 {Agi[i][pluspetit].x=Agi[i][pluspetit].x+Agi[plusgd][i].x;
	  Agi[i][pluspetit].y=Agi[i][pluspetit].y+Agi[plusgd][i].y;
	  Agi[i][pluspetit].w=Agi[i][pluspetit].w+Agi[plusgd][i].w;
	  /* Union en O(1) des listes de r4-arbres dbmt chainees */
	  if (Agi[plusgd][i].Lqd)
	    {if (!Agi[i][pluspetit].Lqd) 
	      Agi[i][pluspetit].Lqd=Agi[plusgd][i].Lqd;
	    else {
	      Agi[i][pluspetit].Lqd->prec->suiv=Agi[plusgd][i].Lqd;
	      Agi[plusgd][i].Lqd->prec->suiv=Agi[i][pluspetit].Lqd;
	      qtmp=Agi[i][pluspetit].Lqd->prec;
	      Agi[i][pluspetit].Lqd->prec=Agi[plusgd][i].Lqd->prec;
	      Agi[plusgd][i].Lqd->prec=qtmp;}}
	}
       else /* pluspetit < plusgd < i */
	 {Agi[i][pluspetit].x=Agi[i][pluspetit].x+Agi[i][plusgd].x;
	  Agi[i][pluspetit].y=Agi[i][pluspetit].y+Agi[i][plusgd].y;
	  Agi[i][pluspetit].w=Agi[i][pluspetit].w+Agi[i][plusgd].w;
	  /* Union en O(1) des listes de r4-arbres dbmt chainees */
	  if (Agi[i][plusgd].Lqd)
	    {if (!Agi[i][pluspetit].Lqd) 
	      Agi[i][pluspetit].Lqd=Agi[i][plusgd].Lqd;
	    else {
	      Agi[i][pluspetit].Lqd->prec->suiv=Agi[i][plusgd].Lqd;
	      Agi[i][plusgd].Lqd->prec->suiv=Agi[i][pluspetit].Lqd;
	      qtmp=Agi[i][pluspetit].Lqd->prec;
	      Agi[i][pluspetit].Lqd->prec=Agi[i][plusgd].Lqd->prec;
	      Agi[i][plusgd].Lqd->prec=qtmp;}
	   }
	}
     }
   }
  } /* pour ch autre noeud */

/* 2: le trou laisse par le nd agrege le plus grand est comble 
   par les nds suivants de la matrice des Agi */

/* on decale a gche les cols a dte */
for (j=plusgd;j<Nb_noeuds_agreg;j++)
  for (i=j+1;i<Nb_noeuds_agreg;i++)
    {Agi[i][j].x=Agi[i][j+1].x;Agi[i][j].y=Agi[i][j+1].y;
     Agi[i][j].w=Agi[i][j+1].w;Agi[i][j].Lqd=Agi[i][j+1].Lqd;}
/* on remonte les ligs du dessous */
for (i=plusgd;i<Nb_noeuds_agreg-1;i++)
  for (j=0;j<i;j++)
    {Agi[i][j].x=Agi[i+1][j].x;Agi[i][j].y=Agi[i+1][j].y;
     Agi[i][j].w=Agi[i+1][j].w;Agi[i][j].Lqd=Agi[i+1][j].Lqd;}

ref[nd1]=-1;ref[nd2]=-1;

/* met a jour les structures de reperages des nds */
for (i=1;i<=cptr;i++) if (ref[i]>plusgd) ref[i]=ref[i]-1;
for (i=1;i<=cptr;i++) if (ref[i]!=-1) refinv[ref[i]]=i; 

/* fait pointer les especes des noeuds agreges nd1 et nd2 sur le neo
   noeud interne */ 
for (i=1;i<=Nb_taxa;i++)
 if ((represent[i]==nd1) || (represent[i]==nd2)) represent[i]=cptr;
}
/*--------------------------------------------------*/
void Separe_noeud_arbre(num,nd1,nd2,xneo,yneo,wneo)
int num,nd1,nd2,xneo,yneo,wneo;
/* Agrege dans la multifourche "num" les noeuds "nd1" et "nd2", en
   creant ds l'arbre un neo noeud relie a leur place a la multifourche */
/* Sauve aussi la neo bipartition creee par cette agglomeration */
{
int tax[Max_nb_taxa];
int cpt1,cpt2;
tarbre *neosom,*ptr1,*ptr2,*ptrmulti;
int i,first=1,second;

ptrmulti=noeuds[Multifourches[num]]; 
if ((neosom=(tarbre *)malloc(sizeof(tarbre)))==0) 
    {printf("MEMORY ALLOCATION ERROR (no more space available)\n");
    fflush(stdout);	/* ++pac */
     exit(-3);}
neosom->num=Num_prochain_noeud;noeuds[neosom->num]=neosom;
for (i=0;i<Max_nb_taxa;i++) neosom->taxa[i]=0; /* ne contient aucun taxon */
/* Le neo noeud a 3 voisins : nd1, nd2 et la multifourche */
neosom->voisins[0]=noeuds[nd1];neosom->voisins[1]=noeuds[nd2];
neosom->voisins[2]=ptrmulti;
for (i=3;i<Max_nb_noeuds;i++) neosom->voisins[i]=NULL;

/* Fait pointer nd1 et nd2 vers lui plutot que vers multifourche */ 
ptr1=noeuds[nd1];ptr2=noeuds[nd2];
for (i=0;(ptr1->voisins[i]!=ptrmulti) && (ptr1->voisins[i]);i++)
if (!ptr1->voisins[i]) 
  {printf("ERR:je trouve pas MULTI\n");fflush(stdout);	/* ++pac */
   exit(-1);}
ptr1->voisins[i]=neosom;
for (i=0;(ptr2->voisins[i]!=ptrmulti) && (ptr2->voisins[i]);i++)
if (!ptr2->voisins[i])
  {printf("ERR:je trouve pas MULTI\n");fflush(stdout);	/* ++pac */
   exit(-1);}
ptr2->voisins[i]=neosom;

/* Remplace nd1 et nd2 par neosom ds les voisins du noeud multifourche */
for (i=0;ptrmulti->voisins[i];i++)
  {
   if ((ptrmulti->voisins[i]==ptr1) || (ptrmulti->voisins[i]==ptr2))
     {if (first)
       {first=0;ptrmulti->voisins[i]=neosom;}
      else second=i;
     }
 }
ptrmulti->voisins[second]=ptrmulti->voisins[i-1]; /* remplace par le dernier*/
ptrmulti->voisins[i-1]=NULL;

  /*****************************************************************/
  /* Calcule la bipartition engendree et l'ajoute a "bipartitions" */
  /*****************************************************************/ 
Nb_Bips++;
cpt1=1;cpt2=0;
for(i=1;i<=Nb_taxa;i++) contient_tax[i]=0;
for (i=1;i<=Nb_taxa;i++)
 if ((represent[i]==nd1) || (represent[i]==nd2))
   {contient_tax[cpt1]=i;bipartition[Nb_Bips][1][cpt1-1]=i;(cpt1)++;}
 else
   {bipartition[Nb_Bips][2][cpt2]=i;(cpt2)++;}
bipartition[Nb_Bips][1][cpt1-1]=0;bipartition[Nb_Bips][2][cpt2]=0;

/*printf("par les REPRESENTANTS je trouve les esps :");
for (i=1;i<=Nb_taxa;i++) printf("%.2d ",contient_tax[i]);
printf("\n"); 
*/

for (i=1;i<=Nb_taxa;i++) tax[i]=0;
for(i=1;contient_tax[i];i++) tax[contient_tax[i]]=1;


for (i=1;i<=Nb_taxa;i++)
    if (tax[i]) fprintf(fbip,"%.2d ",i);
fprintf(fbip,"|");
for (i=1;i<=Nb_taxa;i++)
    if (!tax[i]) fprintf(fbip," %.2d",i);
fprintf(fbip," (32000)\n");
}

/*--------------------------------------------------*/
void glouton(multi)
int multi;
{
int nd1,nd2,etape,xneo,yneo,wneo,i,tmp;
int modifcrit;

     /*---- Boucle principale du glouton ----*/
     /*----         agrege 2 noeuds       ---*/
etape=0;
modifcrit=Choix(&nd1,&nd2);
if (ref[nd1]<ref[nd2]) {tmp=nd1;nd1=nd2;nd2=tmp;}
/*printf("MODIFCRIT = %d\n",modifcrit);*/

/* continue tant qu'on gagne au global (X-Y) (cf Soda) et que Q non vide */ 
while ( (modifcrit>=0) && (Nb_noeuds_agreg>3)) 
  {
  printf(".");fflush(stdout);
  /*printf("(noeuds %d et %d) modifcrit=%d ",nd1,nd2,modifcrit);
  printf("noeuds %d et %d -> %d\n",nd1,nd2,Num_prochain_noeud);*/
  xneo=Agi[ref[nd1]][ref[nd2]].x;
  yneo=Agi[ref[nd1]][ref[nd2]].y;
  wneo=Agi[ref[nd1]][ref[nd2]].w;
  /*printf("on sat %d quad de plus, on en contredit %d de plus 
            et on en resoud %d irresolu ds Q\n",xneo,yneo,zneo);*/

  /* Fait la modif correspondante ds l'arbre */
  Separe_noeud_arbre(multi,nd1,nd2,xneo,yneo,wneo);

  if (Agi[ref[nd1]][ref[nd2]].y==0)
       Gains[etape]=100000.0;
  else Gains[etape]=((float)Agi[ref[nd1]][ref[nd2]].x)
                 /(float)(Agi[ref[nd1]][ref[nd2]].y+Agi[ref[nd1]][ref[nd2]].w);
  /* Sauve valeur au sens du CRITERE GLOBAL X-Y   */
  Critere_global.x+=xneo;
  Critere_global.y+=yneo;
  Critere_global.w+=wneo;

  /* remplace les 2 noeuds agreges par un neo noeud */
  MAJ_Lq_Matrice(nd1,nd2,Num_prochain_noeud);
  Nb_noeuds_agreg--;
  /*Aff_Agi();printf("refinv pr matrice ci-dessus\n");
for (i=0;i<Nb_noeuds_agreg;i++) printf("%d\t",i);printf("\n");
for (i=0;i<Nb_noeuds_agreg;i++) printf("n%d\t",refinv[i]);printf("\n");*/

  Num_prochain_noeud++;
  etape++;
  modifcrit=Choix(&nd1,&nd2);/*printf("MODIFCRIT = %d\n",modifcrit);*/
  if (ref[nd1]<ref[nd2]) {tmp=nd1;nd1=nd2;nd2=tmp;}
  }
/*
if (Nb_noeuds_agreg>3) 
    printf("il reste %d noeuds que je ne departage pas\n",Nb_noeuds_agreg);
else printf("J'ai entierement resolu cette multifourche\n");*/

/*printf("\nCRITERE GLOBAL : %d quad satisfaits \n\t\t%d contredits\n",Critere_global.x,Critere_global.y);
Sauve_Critere();*/

/* 
printf("Les rapports (A) |satisfaits|/|contredits| sont les suivants ds l'ordre
des agglomerations\n (10000 signifie infini, i.e. pas de contredits):\n");
for (i=0;i<etape;i++) printf("%f\n",Gains[i]);
*/
}
/*-------------------------------------*/
void Correspond_nds_ligcol(num)
int num;
{
int i,j,numnd;
Ttaxon *t;
Nb_noeuds_agreg=0;
for (i=0;noeuds[Multifourches[num]]->voisins[i];i++)  Nb_noeuds_agreg++;
/*printf("il y a %d nds a agreger autour de cette multi\n",Nb_noeuds_agreg);*/
/* RAZ la matrice et les refs */
ref[0] = -1;
for (i=0;i<Max_nb_noeuds;i++) ref[i+1]=-1;
for (i=0;i<Max_nb_taxa;i++)
  {
   represent[i+1]=0;  refinv[i]=-1;  Gains[i]=0.0;
   for (j=0;j<Nb_taxa;j++)
      {Agi[i][j].x=0;Agi[i][j].y=0;Agi[i][j].w=0;Agi[i][j].Lqd=NULL;}
  }
/* Positionne les structs de donnees pr traiter la multifourche courante */
for (i=0;i<Nb_noeuds_agreg;i++)
  {numnd=noeuds[Multifourches[num]]->voisins[i]->num;
   refinv[i]=numnd;
   ref[numnd]=i;
   for (t=noeuds[Multifourches[num]]->tax_sousarb[i];t;t=t->suiv)
     represent[t->num]=numnd;
  }
/*printf("\nRepresent taxa(noeud)=\n");
for (i=1;i<=Nb_taxa;i++) printf("%.2d(%d) ",i,represent[i]);printf("\n");
printf("Ref[noeud] = lig/col\n");
for (i=1;i<Num_prochain_noeud;i++) printf("%d(%d) ",i,ref[i]);printf("\n");
printf("Refinv[lig/col] = noeud\n");
for (i=0;i<Nb_taxa;i++) printf("%d(n%d) ",i,refinv[i]);printf("\n");*/
}
/*------------------------------------*/
void Resoud_multi(num)
int num;
/* initialise les structs de donnees avant de lancer glouton */
{
/*Aff_Agi();*/
/* resoud multifourche */
glouton(num);
}









