/***************************************************************************/
/* ALGO de TREE POPPING (BIPARTITIONS --> ARBRE) */
/* On obtient un arbre non-enracine qu'on peut l'enracine ou on veut
   (param).
/*--------------------------------------------------------------------------*/
/* Algorithme pour reconstruire un arbre PAS FORCEMENT BINAIRE depuis un ens 
de bipartitions non conflictuelles */
/* L'arbre est enracine, mais de facon arbitraire. */
/* Et on ne peut pas savoir a l'avance ou il va etre enracine */
/*--------------------------------------------------------------------------*/
/* ENTREE = Liste de bipartitions ds le fichier "bipfile" */
/* SORTIE = "treefile" (ouvert en ajout:"a") arbre sous forme parenthesee */
/*--------------------------------------------------------------------------*/
/* VOIR si DIST_TOPO accepte un arbre non-binaire ??? */
/* voir pour CONSENSE aussi, ainsi que si il analyse correctement le
  consensus d'arbres enracines pas au meme endroit, ie s'il 
  travaille en non-enracine ou pas ???? */
/*--------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define Max_nb_taxa 50
#define Max_nb_noeuds 2*Max_nb_taxa
/* ------- structure de l'arbre ---------- */

typedef struct tarbre {
                       int taxa[Max_nb_taxa];  /* liste non-ordonnee */
		       int num; /* du noeud */
                       struct tarbre *voisins[Max_nb_noeuds]; /* liste non-ordonnee */
                      } tarbre;

/* --------------Var globales-------------- */
/* BIPARTITIONS : numbip | gche ou dte | liste des objets */ 
int bipartition[Max_nb_noeuds+1][3][Max_nb_taxa]; /* utilise 1er indice depuis 1 */

tarbre *noeuds[Max_nb_noeuds+1]; /* adressage direct de chq noeud ds l'arbre */
tarbre *sommet[Max_nb_taxa+1]; /* ptr du taxon vers le sommet de
				    l'arbre qui le contient */
int Nb_taxa,Nb_Bips=0;
int Num_prochain_noeud;
tarbre *Arbre;   /* pointeur sur le noeud de depart */
char name[Max_nb_taxa+1][11];


/*-------------------------------------------*/
void Lit_bipartitions()
{
FILE *f;
char s[11];
int numbip=1,n=0,partie=1,objets=0;
int i,k;
/* RAZ les bips */
for (i=1;i<=Max_nb_noeuds;i++) for(k=0;k<Max_nb_taxa;k++)
  {bipartition[i][1][k]=0;bipartition[i][2][k]=0;}
/* Les charge depuis fichier */
f=fopen("bipfile","r");
/* Lit Nombre de taxa */
fscanf(f,"%d",&Nb_taxa);
/* Lit correspondance numero-nom de taxa */
for (i=1;i<=Nb_taxa;i++)
  fscanf(f,"%d %s\n",&k,&name[i]);
fscanf(f,"\n");
/* Lit les bipartitions */
while (fscanf(f,"%s",s)!=-1)
   {
    /*printf("%s ",s);*/objets++;
    if (!strcmp(s,"|")) {partie++;n=0;}
    else {bipartition[numbip][partie][n]=atoi(s);n++;}
    if (objets==Nb_taxa+1)
	{/* lit le poids de la bipartition*/
	 fscanf(f,"%s",s);/*printf("le pds de la bip est %s\n",s);*/
         n=0;objets=0;numbip++;partie=1;}
   }
Nb_Bips=numbip-1;
/* ----- */
/*printf("j'ai lu %d bipartitions\n",Nb_Bips);
for (i=1;i<=Nb_Bips;i++)
  {
  for(k=0;k<Nb_taxa;k++)
      if (bipartition[i][1][k]!=0)
	  printf("%.2d ",bipartition[i][1][k]);
  printf("| ");
  for(k=0;k<Nb_taxa;k++)
      if (bipartition[i][2][k]!=0)
	  printf("%.2d ",bipartition[i][2][k]);
  printf("\n");
  }*/
}
/*--------------------------------------------*/
Profondeur(Reste,Atteindre,marques,ind_pile,Pile)
int *Reste,Atteindre[Max_nb_taxa+1],marques[Max_nb_noeuds+1],*ind_pile;
tarbre *Pile[Max_nb_noeuds];
{
/* Parcours l'arbre en profondeur en gerant la pile pr le marquage */
int n,i,v=0;
tarbre *s,*som;
/* Si contient des taxa a atteindre marque les noeuds ds la pile
   depuis le dernier marque de la pile */

/*printf("PROF(%d) : reste %d taxa a atteindre\n",*ind_pile,*Reste);
printf("Pile = ");
for (i=0;Pile[i];i++) printf("%.2d ",Pile[i]->num);
printf("\n");*/

som=Pile[(*ind_pile)-1];

for (i=0;som->taxa[i];i++)
  if (Atteindre[som->taxa[i]])
    {
     /* printf("%d trouve,",som->taxa[i]);*/
     (*Reste)--;
     n=(*ind_pile)-1; /* marque depuis le sommet jusqu'au premier som
			 marque recontre ds la pile en la descendant */
     while (!marques[Pile[n]->num]) 
       { /*printf("je marque le noeud %d\n",Pile[n]->num);*/
         marques[Pile[n]->num]=1;
         n--;}
    }
/*  else printf("%.2d bof,",som->taxa[i]);
printf("\n");*/
/*printf("Apres marqu'e taxa du nd %d il m'en reste %d a trouver\n",som->num,*Reste);*/

/* Parcours ses fils tant que certains taxa restent a joindre */
while ((*Reste>0) && (som->voisins[v]))
  {
   if (((*ind_pile)>1) && (Pile[(*ind_pile)-2]==som->voisins[v]) )
       {;/*printf(" son premier voisin est son pere ds la pile\n");*/}
   else
        {
	 s=som->voisins[v];
	 Pile[*ind_pile]=s;(*ind_pile)++; /* empile s */
	 Profondeur(Reste,Atteindre,marques,ind_pile,Pile); 
	 (*ind_pile)--;Pile[*ind_pile]=NULL; /* depile s */
         }
   v++;
  }
}
/*--------------------------------------------*/
void Parcours(b,partie,marques)
int b,partie,marques[Max_nb_noeuds+1];
/* Met dans "marques" le nom de tous les sommets de l'Arbre
   correspondant au sous-arbre d'une des 2 parties de la bipartition b */
/* Pour ca effectue un parcours en profondeur depuis un sommet de
   cette partie */
/* Comme la topologie courante est un arbre on a la propriete que les
   voisins d'un sommet issu du noeud i, ne sont pas d\'ej\`a atteints,
   sauf le voisin qui correspond au noeud i justement. */
/* Pile contient ds une dim le num des noeuds et a cote si ils sont
   marques(1) ou pas(0) */
{
int Atteindre[Max_nb_taxa+1];
tarbre *Pile[Max_nb_noeuds];
int ind_pile,Reste_a_Atteindre=0;
int i,taxon_dep;
/*---- Init ---- */
    /* cree le vecteur de taxa a atteindre pour cet partie -> O(1)
       pour savoir plus tard si un noeud donne doit etre marque ou pas */
    for (i=1;i<=Max_nb_taxa;i++) Atteindre[i]=0;
    for (i=0;bipartition[b][partie][i]!=0;i++) 
      {Atteindre[bipartition[b][partie][i]]=1;Reste_a_Atteindre++;}
    /*printf("les taxa a atteindre sont les suivants :\n");
    printf("123456789....\n");
    for (i=1;i<=Nb_taxa;i++) printf("%d",Atteindre[i]);printf("\n");*/
   /* Init la pile a vide */
   for (i=0;i<Max_nb_noeuds;i++) Pile[i]=NULL;
/*---------------*/

/* On part d'un sommet de Arbre qui est un des som qu'on veut atteindre */
taxon_dep=bipartition[b][partie][0]; /* non vide */
/*printf("depart taxon %d donc du noeud  %d\n",taxon_dep,sommet[taxon_dep]->num);*/
ind_pile=0;
Pile[ind_pile]=sommet[taxon_dep];
marques[sommet[taxon_dep]->num]=1;
ind_pile++;

/* parcours proprement dit */
Profondeur(&Reste_a_Atteindre,Atteindre,marques,&ind_pile,Pile);

}
/*--------------------------------------------*/

int Intersection(gche,dte,noeud)
int gche[Max_nb_noeuds+1],dte[Max_nb_noeuds+1],*noeud;
{
int nb=0,i;
for (i=1;i<=Max_nb_noeuds;i++)
 if ((gche[i]) && (dte[i])) {nb++;*noeud=i;}
return(nb);}
/*--------------------------------------------*/
int Appartient(b,part,taxon)
int b,part,taxon;
{
int trouve=0,t=0;
while ((!trouve) && (bipartition[b][part][t])) 
 {if (bipartition[b][part][t]==taxon) trouve=1;
  t++;}
return(trouve);
}
/*--------------------------------------------*/
void Scinde(nd,b,arbG,arbD)
int nd,b,arbG[Max_nb_noeuds+1],arbD[Max_nb_noeuds+1];
{
/* separe le noeud en 2 et repartit les voisins de l'ancien noeud de
   fa\c{c}on a ce que les sous-arbres associes a chq partie de la
   bipartition en question soient connexes */
tarbre *neosom,*noeud,*vois;
int ind,ivieux,nbvois,i,j,v,vvieux;
tarbre *voisin_Dt[Max_nb_noeuds];
int taxa_Dt[Max_nb_taxa];
noeud=noeuds[nd];
neosom=(tarbre *)malloc(sizeof(tarbre));
neosom->num=Num_prochain_noeud;Num_prochain_noeud++;noeuds[neosom->num]=neosom;
/* lui associe les TAXA de l'ancien appartenant a la partie gche de la
   bipartition : O(n) */
ind=0;ivieux=0;
for (i=0;noeud->taxa[i];i++)
  {
   if (Appartient(b,1,noeud->taxa[i]))
     {neosom->taxa[ind]=noeud->taxa[i];ind++;
      sommet[noeud->taxa[i]]=neosom;}
   else {taxa_Dt[ivieux]=noeud->taxa[i];ivieux++;}
  }


/* ATTENTION CORRECTION : 
   LA LIGNE SUIVANTE A ETE CORRIGEE : ELLE INITIALISAIT J=I AU LIEU DE J=IND*/

for (j=ind;j<Max_nb_taxa;j++) neosom->taxa[j]=0;           




/* a l'ancien laisse les taxa de la partie dte */
for (i=0;i<ivieux;i++) 
  {noeud->taxa[i] = taxa_Dt[i];}
for (j=i;j<Max_nb_taxa;j++) noeud->taxa[j]=0;

/*
printf("les taxa associes au neo noeud (%d) sont : ",neosom->num);
for (i=0;i<Max_nb_taxa;i++) 
   if (neosom->taxa[i]) printf("%.2d ",neosom->taxa[i]);
printf("\n");
printf("les taxa associes a l'ancien noeud sont : ");
for (i=0;i<Max_nb_taxa;i++) 
   if (noeud->taxa[i]) printf("%.2d ",noeud->taxa[i]);
printf("\n");*/

/* lui associe les voisins de l'ancien sommet qui appartiennent au
   sous-arbre associe a la partie gche de la bipartition. Les voisins
   de l'autre sousarbre les met ds voisin_Dt : O(n) */

/* printf("les voisins a partager sont ");
for (v=0;noeud->voisins[v];v++) printf("%.2d ",noeud->voisins[v]->num);
printf("\n");*/
v=0;
vvieux=0;nbvois=0;

while (noeud->voisins[vvieux])
  {
   if (arbG[noeud->voisins[vvieux]->num])
      {neosom->voisins[v]=noeud->voisins[vvieux];v++;}
   else {voisin_Dt[nbvois]=noeud->voisins[vvieux];nbvois++;} 
   vvieux++;
   }


/* ATTENTION CORRECTION : 
   LA LIGNE SUIVANTE A ETE AJOUTEE : AUCUN DERNIER VOISIN N'ETAIT INDIQUE */


neosom->voisins[v]=NULL;




/* chge le pointeur des noeuds VOISINS vers le neo noeud : O(n) */
for (v=0;neosom->voisins[v];v++)
  {
   vois=neosom->voisins[v];
   for (i=0;(vois->voisins[i]) && (vois->voisins[i]!=noeud);i++)   ;
   if (!vois->voisins[i]) 
     {printf("ERREUR : je ne trouve pas l'ancien noeud ds la liste des");
      printf("voisins de ses voisins\n");exit(-1);}
   vois->voisins[i]=neosom;
  }

/* garde que les voisins de la sousarb dte dans l'ancien noeud */
for (i=0;i<nbvois;i++) noeud->voisins[i]=voisin_Dt[i];
for (i=nbvois;i<Max_nb_noeuds;i++) noeud->voisins[i]=NULL;

/* ajoute une arete entre le neo et l'ancien noeud */
noeud->voisins[nbvois]=neosom;
neosom->voisins[v]=noeud;v++;neosom->voisins[v]=NULL;

/* printf("les noeuds voisins du neo som sont : ");
for (i=0;neosom->voisins[i];i++) printf("%.2d ",neosom->voisins[i]->num);
printf("\n");
 
printf("les noeuds voisins de l'ancien som sont : ");
for (i=0;noeud->voisins[i];i++) printf("%.2d ",noeud->voisins[i]->num);
printf("\n");

printf("Taxa(noeud) = ");for (i=1;sommet[i];i++) printf("%.2d(%d) ",i,sommet[i]->num); 
printf("\n");*/

}


/*--------------------------------------------*/
void Integre_bipartition(b)
int b;
/* Traite la bieme bipartition */
{
int noeud=-1;
int parcours_gche[Max_nb_noeuds+1],parcours_dte[Max_nb_noeuds+1]; 
int i;

/* si il s'agit de la bipartition triviale ne rien faire */
if ((bipartition[b][1][0]==0) || (bipartition[b][2][0]==0)) 
   {/*printf("il s'agit d'une bipartition vide\n");*/return;}
/* Init */
for (i=0;i<=Max_nb_noeuds;i++) {parcours_gche[i]=0;parcours_dte[i]=0;}
/* Cherche noeuds de partie gche */
Parcours(b,1,parcours_gche);
/*printf("Sous-arbre gche = noeuds ");
for (i=1;i<=Max_nb_noeuds;i++) 
  if (parcours_gche[i]) printf("%.2d ",i); printf("\n");*/
/* Cherche noeuds de partie dte */
Parcours(b,2,parcours_dte);
/* printf("Sous-arbre dt = noeuds ");
for (i=1;i<=Max_nb_noeuds;i++) 
  if (parcours_dte[i]) printf("%.2d ",i); printf("\n");*/
/* Si intersection == 2 noeuds -> incompatibilite 
                   == 0 noeuds -> rien faire 
		   == 1 noeud -> le separer en 2 */

switch (Intersection(parcours_gche,parcours_dte,&noeud))
	{
	case 0:return;break;
	case 2:{printf("BIPARTITION INCOMPATIBLE !!!!\n");exit(-1);}break;
	case 1:{/*printf("je recois le noeud %.2d comme seule intersection\n",noeud);*/
		Scinde(noeud,b,parcours_gche,parcours_dte);}
        }
}

/*--------------------------------------------------*/
void Sauve_Arbre(f,noeud,pere)
FILE *f;tarbre *noeud,*pere;
{
int i,prem;
/* Produit un arbre ENRACINE depuis la structure de donnees */
/* affiche ses taxa */
for (i=0;noeud->taxa[i];i++) fprintf(f,"%s",name[noeud->taxa[i]]);
/* recurse */
if (noeud->voisins[1]) /* a un autre voisin que son pere */
    {
     fprintf(f,"(");prem=1;
     for (i=0;noeud->voisins[i];i++)
       {
	  if (noeud->voisins[i]!=pere)  
	    {if (!prem) fprintf(f,",");
	     else prem=0;
	     Sauve_Arbre(f,noeud->voisins[i],noeud);
	    }
	}
     fprintf(f,")");
    }
}
/*--------------------------------------------------*/
void main(argc, argv)
int argc;char *argv[];
{extern char *optarg;
FILE *farb;
char c;
int i,j,k;
Nb_taxa=4; /* par defaut */

Lit_bipartitions();
printf("%d taxa\n",Nb_taxa);
printf("Tree output in file : treefile\n");
/*--- Init arbre avec ts les taxa ds un noeud --*/
Arbre=(tarbre *)malloc(sizeof(tarbre));
for (i=0;i<Nb_taxa;i++) {Arbre->taxa[i]=i+1;sommet[i+1]=Arbre;}
for (i=Nb_taxa;i<Max_nb_taxa;i++) {Arbre->taxa[i]=0;sommet[i+1]=NULL;}
for (i=1;i<=Max_nb_noeuds;i++) noeuds[i]=NULL;
Arbre->num=1;Num_prochain_noeud=2;noeuds[1]=Arbre;
Arbre->voisins[0]=NULL;
/*-----------*/

for (i=1;i<=Nb_Bips;i++) Integre_bipartition(i);

farb=fopen("treefile","w");
fprintf(farb,"(%s,",name[1]);
Sauve_Arbre(farb,sommet[1]->voisins[0],sommet[1]); /* enracine au taxon 1 */
fprintf(farb,");\n");
fclose(farb);
}
/*--------------------------------------------------*/


